#ifndef __PLAYERINFO_HPP__
#define __PLAYERINFO_HPP__

// CN[h
#include <windows.h>

// STL
#pragma warning(disable : 4786)
#include <map>
using namespace std;

// `
#define PI_MAXCOUNT 500			// ێł
#define PIS_INCOMPLETE 0		// 0:񖢊
#define PIS_COMPLETED 1			// 3:擾

typedef struct
{
	DWORD dwID;
	char szName[30];
	char szParty[30];
	char szGuild[30];
	char szPosition[30];
	BYTE nLevel;
	BYTE nSex;
	WORD nType;
	WORD nWeapon;
	WORD nShield;
	WORD nHead1;
	WORD nHead2;
	WORD nHead3;
	POINT stPoint;
	int nRequestState;
} PLAYERINFO;

// O[oϐ
map<DWORD, PLAYERINFO> g_mapPlayerInfo;

//////////////////////////////////////////////////////////////////

// 
void ClearPlayerInfo()
{
	g_mapPlayerInfo.clear();
}

// 폜
// ̃\[XZbgł͈xgpȂǈꉞ
void DeletePlayerInfo(DWORD dwID)
{
	g_mapPlayerInfo.erase(dwID);
}

// 
bool GetPlayerInfo(PLAYERINFO *pPI)
{
	map<DWORD, PLAYERINFO>::iterator it;

	it = g_mapPlayerInfo.find(pPI->dwID);
	if (it != g_mapPlayerInfo.end())
		*pPI = it->second;

	return (it != g_mapPlayerInfo.end());
}

// XV
bool SetPlayerInfo(PLAYERINFO *pPI)
{
	PLAYERINFO stPI;
	map<DWORD, PLAYERINFO>::iterator it;

	ZeroMemory(&stPI, sizeof(stPI));
	it = g_mapPlayerInfo.find(pPI->dwID);
	if (it != g_mapPlayerInfo.end())
	{
		stPI = it->second;
		it->second = *pPI;
	}
	else
	{
		// ǉ
		
		// ̍ői[𒴂ꍇ1폜
		// stl::map̓L[\[g邽߁A
		// uŏ̗vfvƌ肷邱Ƃ͂܂悭Ȃ
		// ȂPɂ܂邽߂ɂȂĂ܂
		if (g_mapPlayerInfo.size() >= PI_MAXCOUNT)
			g_mapPlayerInfo.erase(g_mapPlayerInfo.begin());

		g_mapPlayerInfo[pPI->dwID] = *pPI;
	}
	return (memcmp(&stPI, pPI, sizeof(PLAYERINFO) - sizeof(WORD) * 5 - sizeof(POINT) - sizeof(int)) != 0);
}

#endif // __PLAYERINFO_HPP__
