/*
	AreID.cpp
	ꂪC̃\[XBPacketProc.cpp
*/

// CN[h
#include <windows.h>
#include <stdio.h>
#include "PlayerInfo.hpp"
#include "RoInfoTable.hpp"

// `
#define PI_IDMASK 0xFFFF0000

// O[oϐ
DWORD (WINAPI *GetVariable)(LPCTSTR) = NULL;
int (WINAPI *SendPacket)(const LPBYTE, int) = NULL;

char g_szMapName[17];
DWORD g_dwFlag = -1; // 0xFFFFFFFF
bool g_bConsole = false;		// R\[ւ̏o
bool g_bAutoRequest = false;	// NGXg

////////////////////////////////////////////////////////////////

// R\[ɏo
void DumpConsole(char *pszMessage)
{
	if (g_bConsole)
		WriteConsole(GetStdHandle(STD_OUTPUT_HANDLE), pszMessage, lstrlen(pszMessage), NULL, NULL);
}

// Wϊ1
void MakeCoords(POINT *pPoint, LPBYTE pBuf)
{
	pPoint->x = ((pBuf[0] << 2) & 0xFF) | ((pBuf[1] & 0xC0) >> 6);
	pPoint->y = ((pBuf[1] & 0x3F) << 4) | ((pBuf[2] & 0xF0) >> 4);
}

// Wϊ2
void MakeCoords2(POINT *pPoint, LPBYTE pBuf)
{
	pPoint->x = ((pBuf[1] & 0xFC) >> 2) | (((pBuf[0] & 0x0F) << 6) & 0xFF);
	pPoint->y = ((pBuf[1] & 0x03) << 8) | pBuf[2];
}

// vC[̏o
bool OutputPlayerInfo(PLAYERINFO *pPI) 
{
	if ((g_dwFlag & 0x1FFF) == 0)
		return false;

	// T[o[o͂Ȃ̂
	// 擾pȂłB

	FILE *fp;
	SYSTEMTIME now;
	char szName[30];
	char szParty[30];
	char szGuild[30];
	char szPosition[30];
	char szFileName[MAX_PATH];

	GetLocalTime(&now);
	sprintf(szName, "\"%s\"", pPI->szName);
	sprintf(szParty, "\"%s\"", pPI->szParty);
	sprintf(szGuild, "\"%s\"", pPI->szGuild);
	sprintf(szPosition, "\"%s\"", pPI->szPosition);
	sprintf(szFileName, "idlog\\uid%04d%02d%02d.txt", now.wYear, now.wMonth, now.wDay);

	for(int i = 0; i < sizeof(szName); i++)
	{
		if (szName[i] == '\t') szName[i] = ' ';
		if (szParty[i] == '\t') szParty[i] = ' ';
		if (szGuild[i] == '\t') szGuild[i] = ' ';
		if (szPosition[i] == '\t') szPosition[i] = ' ';
		// isspace()łǃXebvlĎO
		if (0x09 <= szName[i] && szName[i] <= 0x0D) szName[i] = '';
		if (0x09 <= szParty[i] && szParty[i] <= 0x0D) szParty[i] = '';
		if (0x09 <= szGuild[i] && szGuild[i] <= 0x0D) szGuild[i] = '';
		if (0x09 <= szPosition[i] && szPosition[i] <= 0x0D) szPosition[i] = '';
	}

	if (GetFileAttributes(szFileName) == -1)
	{
		fp = fopen(szFileName, "a");
		if (fp == NULL)
			return false;

		// [vɂׂȂ̂łR[hȂ̂
		// WJ܂B蔲RsyƂ܂B
		//                            123456789012345678901234567890
		if (g_dwFlag & 0x0001) fputs("Date      ", fp);
		if ((g_dwFlag % 0x0002) && (g_dwFlag & 0x0002)) fputc(' ', fp); 
		if (g_dwFlag & 0x0002) fputs("Time    ", fp);
		if ((g_dwFlag % 0x0004) && (g_dwFlag & 0x0004)) fputc(' ', fp); 
		if (g_dwFlag & 0x0004) fputs("ID        ", fp);
		if ((g_dwFlag % 0x0008) && (g_dwFlag & 0x0008)) fputc(' ', fp); 
		if (g_dwFlag & 0x0008) fputs("CharacterName             ", fp);
		if ((g_dwFlag % 0x0010) && (g_dwFlag & 0x0010)) fputc(' ', fp); 
		if (g_dwFlag & 0x0010) fputs("MapName      ", fp);
		if ((g_dwFlag % 0x0020) && (g_dwFlag & 0x0020)) fputc(' ', fp); 
		if (g_dwFlag & 0x0020) fputs("X   Y  ", fp);
		if ((g_dwFlag % 0x0040) && (g_dwFlag & 0x0040)) fputc(' ', fp); 
		if (g_dwFlag & 0x0040) fputs("Party                     ", fp);
		if ((g_dwFlag % 0x0080) && (g_dwFlag & 0x0080)) fputc(' ', fp); 
		if (g_dwFlag & 0x0080) fputs("Guild                     ", fp);
		if ((g_dwFlag % 0x0100) && (g_dwFlag & 0x0100)) fputc(' ', fp); 
		if (g_dwFlag & 0x0100) fputs("Position                  ", fp);
		if ((g_dwFlag % 0x0100) && (g_dwFlag & 0x0100)) fputc(' ', fp); 
		if (g_dwFlag & 0x0200) fputs("Job         ", fp);
		if ((g_dwFlag % 0x0400) && (g_dwFlag & 0x0400)) fputc(' ', fp); 
		if (g_dwFlag & 0x0400) fputs("Sex ", fp);
		if ((g_dwFlag % 0x0800) && (g_dwFlag & 0x0800)) fputc(' ', fp); 
		if (g_dwFlag & 0x0800) fputs("Lv", fp);
		if ((g_dwFlag % 0x1000) && (g_dwFlag & 0x1000)) fputc(' ', fp); 
		if (g_dwFlag & 0x1000) fputs("Head1  Head2  Head3  Weapon  Shield", fp);
		fputc('\n', fp);
		fclose(fp);
	}

	fp = fopen(szFileName, "a");
	if (fp == NULL)
		return false;

	// [vɂׂȂ̂łR[hȂ̂
	// WJ܂B蔲RsyƂ܂B
	if (g_dwFlag & 0x0001) fprintf(fp, "%04d/%02d/%02d", now.wYear, now.wMonth, now.wDay);
	if ((g_dwFlag % 0x0002) && (g_dwFlag & 0x0002)) fputc(' ', fp); 
	if (g_dwFlag & 0x0002) fprintf(fp, "%02d:%02d:%02d", now.wHour, now.wMinute, now.wSecond);
	if ((g_dwFlag % 0x0004) && (g_dwFlag & 0x0004)) fputc(' ', fp); 
	if (g_dwFlag & 0x0004) fprintf(fp, "0x%08x", pPI->dwID);
	if ((g_dwFlag % 0x0008) && (g_dwFlag & 0x0008)) fputc(' ', fp); 
	if (g_dwFlag & 0x0008) fprintf(fp, "%-26s", szName);
	if ((g_dwFlag % 0x0010) && (g_dwFlag & 0x0010)) fputc(' ', fp); 
	if (g_dwFlag & 0x0010) fprintf(fp, "%-13s", g_szMapName);
	if ((g_dwFlag % 0x0020) && (g_dwFlag & 0x0020)) fputc(' ', fp); 
	if (g_dwFlag & 0x0020) fprintf(fp, "%3d %3d", pPI->stPoint.x, pPI->stPoint.y);
	if ((g_dwFlag % 0x0040) && (g_dwFlag & 0x0040)) fputc(' ', fp); 
	if (g_dwFlag & 0x0040) fprintf(fp, "%-26s", szParty);
	if ((g_dwFlag % 0x0080) && (g_dwFlag & 0x0080)) fputc(' ', fp); 
	if (g_dwFlag & 0x0080) fprintf(fp, "%-26s", szGuild);
	if ((g_dwFlag % 0x0100) && (g_dwFlag & 0x0100)) fputc(' ', fp); 
	if (g_dwFlag & 0x0100) fprintf(fp, "%-26s", szPosition);
	if ((g_dwFlag % 0x0200) && (g_dwFlag & 0x0200)) fputc(' ', fp); 
	if (g_dwFlag & 0x0200) fprintf(fp, "%-12s", GetJobString(pPI->nType).c_str());
	if ((g_dwFlag % 0x0400) && (g_dwFlag & 0x0400)) fputc(' ', fp); 
	if (g_dwFlag & 0x0400) fprintf(fp, "%-4s", GetSexString(pPI->nSex).c_str());
	if ((g_dwFlag % 0x0800) && (g_dwFlag & 0x0800)) fputc(' ', fp); 
	if (g_dwFlag & 0x0800) fprintf(fp, "%2d", pPI->nLevel);
	if ((g_dwFlag % 0x1000) && (g_dwFlag & 0x1000)) fputc(' ', fp); 
	if (g_dwFlag & 0x1000) fprintf(fp, "%s %s %s %s %s",
			GetItemName(pPI->nHead1).c_str(), GetItemName(pPI->nHead2).c_str(), GetItemName(pPI->nHead3).c_str(), GetItemName(pPI->nWeapon).c_str(), GetItemName(pPI->nShield).c_str());
	fputc('\n', fp);
	fclose(fp);
	return true;
}

// W[ɌĂ΂֐
void WINAPI Initialize(HMODULE hModule)
{
	*(FARPROC*)&GetVariable = GetProcAddress(hModule, "GetVariable");
	*(FARPROC*)&SendPacket = GetProcAddress(hModule, "SendPacket");
	lstrcpy(g_szMapName, "}bvs");
}

// ݒǂݍݎɌĂ΂֐
void WINAPI LoadConfig()
{
	g_bAutoRequest = (GetVariable("areid_auto_request") != 0);
	g_bConsole = (GetVariable("areid_output_console") != 0);
	g_dwFlag = GetVariable("areid_output_flag");
	LoadItemTable("ItemNameTable.txt");
}

// pPbg擾ɌĂ΂֐
int WINAPI OnRecv(LPBYTE pBuf, int nLen)
{
	if (nLen < 2)
		return nLen;
		
	WORD nCmd = *(LPWORD)pBuf;
	BYTE szBuf[6] = { 0x94, 0x00 };
	PLAYERINFO stPI;
	ZeroMemory(&stPI, sizeof(PLAYERINFO));
	
	// OCI/LZI/Q[I ڑ
	if (nCmd == 0x0069 || nCmd == 0x006B || nCmd == 0x0073)
	{
		ClearPlayerInfo();
	}
	// }bvNGXg
	else if (nCmd == 0x71 || nCmd == 0x0091 || nCmd == 0x0092)
	{
		ClearPlayerInfo();
		lstrcpy(g_szMapName, (nCmd == 0x71) ? (char*)&pBuf[6] : (char*)&pBuf[2]);
		char* pFind = strchr(g_szMapName, '.');
		if (pFind != NULL) *pFind = '\0';
	}
	// vC[
	else if (nCmd == 0x01D8 || nCmd == 0x01D9 || nCmd == 0x01DA)
	{
		stPI.dwID = *(LPDWORD)&pBuf[2];

		if (stPI.dwID & PI_IDMASK)
		{
			GetPlayerInfo(&stPI);
			stPI.nType = *(LPWORD)&pBuf[14];
			if (nCmd == 0x01DA)
			{
				stPI.nSex = pBuf[49];
				stPI.nLevel = pBuf[58];
				stPI.nHead1 = *(LPWORD)&pBuf[28];
				stPI.nHead2 = *(LPWORD)&pBuf[30];
				stPI.nHead3 = *(LPWORD)&pBuf[22];
				stPI.nWeapon = *(LPWORD)&pBuf[18];
				stPI.nShield = *(LPWORD)&pBuf[20];
				MakeCoords2(&stPI.stPoint, &pBuf[52]);
			}
			else
			{
				stPI.nSex = pBuf[45];
				stPI.nLevel = (nCmd == 0x01D8) ? pBuf[52] : pBuf[51];
				stPI.nHead1 = *(LPWORD)&pBuf[24];
				stPI.nHead2 = *(LPWORD)&pBuf[26];
				stPI.nHead3 = *(LPWORD)&pBuf[22];
				stPI.nWeapon = *(LPWORD)&pBuf[18];
				stPI.nShield = *(LPWORD)&pBuf[20];
				MakeCoords(&stPI.stPoint, &pBuf[46]);
			}
			// ωꍇAIDLƂƂl
			// čĎ擾\Ƃ
			if (SetPlayerInfo(&stPI))
				stPI.nRequestState = PIS_INCOMPLETE;

			// 0x01D8̓Q[T[o[ڑȂǈCɗĂ邽߁A
			// 擾̑ΏۂƂȂ
			if (g_bAutoRequest && nCmd != 0x01D8)
			{
				*(LPDWORD)&szBuf[2] = stPI.dwID;
				SendPacket(szBuf, sizeof(szBuf));
			}
		}
	}
	// LN^[̏
	else if (nCmd == 0x0080)
	{
		stPI.dwID = *(LPDWORD)&pBuf[2];

		if ((stPI.dwID & PI_IDMASK) && g_bAutoRequest)
		{
			// őOɖOvĂ
			if (GetPlayerInfo(&stPI) && stPI.nRequestState != PIS_COMPLETED)
			{
				*(LPDWORD)&szBuf[2] = stPI.dwID;
				SendPacket(szBuf, sizeof(szBuf));
			}
		}
	}
	// LN^[M
	else if (nCmd == 0x0095 || nCmd == 0x0195)
	{
		stPI.dwID = *(LPDWORD)&pBuf[2];
		
		if (stPI.dwID & PI_IDMASK)
		{
			if (GetPlayerInfo(&stPI) && stPI.nRequestState != PIS_COMPLETED)
			{
				stPI.nRequestState = PIS_COMPLETED;
				ZeroMemory(&stPI.szName, sizeof(stPI.szName) * 4);
				CopyMemory(stPI.szName, &pBuf[6], min(lstrlen((char*)&pBuf[6]), 24));
				if (nCmd != 0x0095)
				{
					CopyMemory(stPI.szParty, &pBuf[30], min(lstrlen((char*)&pBuf[30]), 24));
					CopyMemory(stPI.szGuild, &pBuf[54], min(lstrlen((char*)&pBuf[54]), 24));
					CopyMemory(stPI.szPosition, &pBuf[78], min(lstrlen((char*)&pBuf[78]), 24));
				}
				SetPlayerInfo(&stPI);
				OutputPlayerInfo(&stPI);

				char szMessage[128];
				sprintf(szMessage, "AreID > ID:%08x Name:%s Job:%s Sex:%s Lv:%d\n",
					stPI.dwID, stPI.szName, GetJobString(stPI.nType).c_str(), GetSexString(stPI.nSex).c_str(), stPI.nLevel);
				DumpConsole(szMessage);
			}
		}
	}
	// ύX
	else if (nCmd == 0x01D7)
	{
		stPI.dwID = *(LPDWORD)&pBuf[2];
		
		if ((stPI.dwID & PI_IDMASK) && pBuf[6] == 0x02)
		{
			// OMOł΂ł邾V
			if (GetPlayerInfo(&stPI) && stPI.nRequestState != PIS_COMPLETED)
			{
				stPI.nWeapon = *(LPWORD)&pBuf[7];
				stPI.nShield = *(LPWORD)&pBuf[9];
				SetPlayerInfo(&stPI);
			}
		}
	}
	else if (nCmd == 0x00C3)
	{
		// ύX
		stPI.dwID = *(LPDWORD)&pBuf[2];
		
		if (stPI.dwID & PI_IDMASK)
		{
			// OMOł΂ł邾V
			if (GetPlayerInfo(&stPI) && stPI.nRequestState != PIS_COMPLETED)
			{
				switch(pBuf[6])
				{
				case 0x04:
					// head1ύX
					stPI.nHead1 = pBuf[7];
					break;
				case 0x05:
					// head2ύX
					stPI.nHead2 = pBuf[7];
					break;
				case 0x03:
					// head3ύX
					stPI.nHead3 = pBuf[7];
					break;
				}
				SetPlayerInfo(&stPI);
			}
		}
	}
	return nLen;
}

// Gg
BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID pReserved)
{
	// ĂȂǈꉞ
	switch(dwReason)
	{
	case DLL_PROCESS_ATTACH:
		break;
	case DLL_PROCESS_DETACH:
		break;
	}
	return true;
}
